import * as React from 'react';
import { AccessibilityRole, AccessibilityState } from 'react-native';
import { NavigationViewProps } from '../utils/createTabNavigator';
import { NavigationProp, Route, SceneDescriptor, NavigationBottomTabOptions, BottomTabBarOptions } from '../types';
declare type Props = NavigationViewProps & {
    getAccessibilityRole: (props: {
        route: Route;
    }) => AccessibilityRole | undefined;
    getAccessibilityStates: (props: {
        route: Route;
        focused: boolean;
    }) => AccessibilityState[];
    lazy?: boolean;
    tabBarComponent?: React.ComponentType<any>;
    tabBarOptions?: BottomTabBarOptions;
    navigation: NavigationProp;
    descriptors: {
        [key: string]: SceneDescriptor<NavigationBottomTabOptions>;
    };
    screenProps?: unknown;
};
declare const _default: (routes: {
    [key: string]: (React.ComponentClass<any, any> & {
        navigationOptions?: (import("../types").NavigationCommonTabOptions & {
            tabBarButtonComponent?: React.ComponentClass<import("../types").BottomTabBarProps, any> | React.FunctionComponent<import("../types").BottomTabBarProps> | undefined;
        } & {
            [key: string]: any;
        }) | undefined;
    }) | (React.FunctionComponent<any> & {
        navigationOptions?: (import("../types").NavigationCommonTabOptions & {
            tabBarButtonComponent?: React.ComponentClass<import("../types").BottomTabBarProps, any> | React.FunctionComponent<import("../types").BottomTabBarProps> | undefined;
        } & {
            [key: string]: any;
        }) | undefined;
    }) | ({
        screen: import("../types").Screen<NavigationBottomTabOptions>;
    } & {
        path?: string | undefined;
        navigationOptions?: NavigationBottomTabOptions | ((options: {
            navigation: NavigationProp<string, object>;
        }) => NavigationBottomTabOptions) | undefined;
    }) | ({
        getScreen(): import("../types").Screen<NavigationBottomTabOptions>;
    } & {
        path?: string | undefined;
        navigationOptions?: NavigationBottomTabOptions | ((options: {
            navigation: NavigationProp<string, object>;
        }) => NavigationBottomTabOptions) | undefined;
    });
}, config: NavigationBottomTabOptions) => React.ComponentType<Pick<Props, "navigation" | "screenProps" | "descriptors" | "getAccessibilityRole" | "getAccessibilityStates" | "lazy" | "tabBarComponent" | "tabBarOptions"> & {
    navigationConfig: any;
}>;
export default _default;
