import * as React from 'react';
import { StyleProp, ViewStyle } from 'react-native';
import { NavigationViewProps } from '../utils/createTabNavigator';
import { NavigationProp, SceneDescriptor, NavigationMaterialTabOptions, MaterialTabBarOptions } from '../types';
declare type Route = {
    key: string;
    routeName: string;
};
declare type Props = NavigationViewProps & {
    keyboardDismissMode?: 'none' | 'on-drag';
    swipeEnabled?: boolean;
    swipeDistanceThreshold?: number;
    swipeVelocityThreshold?: number;
    onSwipeStart?: () => void;
    onSwipeEnd?: () => void;
    initialLayout?: {
        width?: number;
        height?: number;
    };
    lazy?: boolean;
    lazyPlaceholderComponent?: React.ComponentType<{
        route: Route;
    }>;
    tabBarComponent?: React.ComponentType<any>;
    tabBarOptions?: MaterialTabBarOptions;
    tabBarPosition?: 'top' | 'bottom';
    sceneContainerStyle?: StyleProp<ViewStyle>;
    style?: StyleProp<ViewStyle>;
    navigation: NavigationProp;
    descriptors: {
        [key: string]: SceneDescriptor<NavigationMaterialTabOptions>;
    };
    screenProps?: unknown;
};
declare const _default: (routes: {
    [key: string]: (React.ComponentClass<any, any> & {
        navigationOptions?: (import("../types").NavigationCommonTabOptions & {
            tabBarButtonComponent?: React.ComponentClass<any, any> | React.FunctionComponent<any> | undefined;
            swipeEnabled?: boolean | ((state: import("../types").NavigationState) => boolean) | undefined;
        } & {
            [key: string]: any;
        }) | undefined;
    }) | (React.FunctionComponent<any> & {
        navigationOptions?: (import("../types").NavigationCommonTabOptions & {
            tabBarButtonComponent?: React.ComponentClass<any, any> | React.FunctionComponent<any> | undefined;
            swipeEnabled?: boolean | ((state: import("../types").NavigationState) => boolean) | undefined;
        } & {
            [key: string]: any;
        }) | undefined;
    }) | ({
        screen: import("../types").Screen<NavigationMaterialTabOptions>;
    } & {
        path?: string | undefined;
        navigationOptions?: NavigationMaterialTabOptions | ((options: {
            navigation: NavigationProp<string, object>;
        }) => NavigationMaterialTabOptions) | undefined;
    }) | ({
        getScreen(): import("../types").Screen<NavigationMaterialTabOptions>;
    } & {
        path?: string | undefined;
        navigationOptions?: NavigationMaterialTabOptions | ((options: {
            navigation: NavigationProp<string, object>;
        }) => NavigationMaterialTabOptions) | undefined;
    });
}, config: NavigationMaterialTabOptions) => React.ComponentType<Pick<Props, "style" | "navigation" | "screenProps" | "descriptors" | "lazy" | "tabBarComponent" | "tabBarOptions" | "tabBarPosition" | "keyboardDismissMode" | "swipeEnabled" | "swipeDistanceThreshold" | "swipeVelocityThreshold" | "onSwipeStart" | "onSwipeEnd" | "initialLayout" | "lazyPlaceholderComponent" | "sceneContainerStyle"> & {
    navigationConfig: any;
}>;
export default _default;
