import * as React from 'react';
import { NavigationProp, SceneDescriptor, Route, Screen, NavigationCommonTabOptions } from '../types';
declare type RouteConfig<Options> = {
    [key: string]: Screen<Options> | (({
        screen: Screen<Options>;
    } | {
        getScreen(): Screen<Options>;
    }) & {
        path?: string;
        navigationOptions?: Options | ((options: {
            navigation: NavigationProp;
        }) => Options);
    });
};
declare type CommonProps<Options> = {
    navigation: NavigationProp;
    descriptors: {
        [key: string]: SceneDescriptor<Options>;
    };
    screenProps?: unknown;
};
declare type ExtraProps = {
    navigationConfig: any;
};
export declare type RenderIconProps = {
    route: Route;
    focused: boolean;
    tintColor?: string;
    horizontal?: boolean;
};
export declare type NavigationViewProps = {
    getLabelText: (props: {
        route: Route;
    }) => string | undefined;
    getAccessibilityLabel: (props: {
        route: Route;
    }) => string | undefined;
    getTestID: (props: {
        route: Route;
    }) => string | undefined;
    renderIcon: (props: RenderIconProps) => React.ReactNode;
    renderScene: (props: {
        route: Route;
    }) => React.ReactNode;
    onIndexChange: (index: number) => void;
    onTabPress: (props: {
        route: Route;
    }) => void;
    onTabLongPress: (props: {
        route: Route;
    }) => void;
};
export default function createTabNavigator<Options extends NavigationCommonTabOptions, Props extends NavigationViewProps & CommonProps<Options>>(TabView: React.ComponentType<Props>): (routes: RouteConfig<Options>, config: Options) => React.ComponentType<Pick<Props, Exclude<keyof Props, keyof NavigationViewProps>> & ExtraProps>;
export {};
